<?php

    /**
    * Allows managing categories
    * 
    * @package    mod-magtest
    * @category   mod
    * @author     Valery Fremaux <valery.fremaux@club-internet.fr>
    * @contributors   Etienne Roze
    * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL
    * @copyright  (C) 1999 onwards Martin Dougiamas  http://dougiamas.com
    * @see        categories.controller.php for associated controller.
    */

    if (!defined('MOODLE_INTERNAL')) {
        error('You cannot access directly to this page');
    }

    $categories = magtest_get_categories($magtest->id);

    print_heading('categories', 'magtest');

    echo "<center>";

    print_box_start();

    if (!empty($categories)){
    
        $symbolstr   = get_string('symbol', 'magtest');
        $namestr   = get_string('name');
        $descriptionstr = get_string('description');
        $resultstr = get_string('categoryresult', 'magtest');
        $commandstr     = get_string('commands', 'magtest');
        
        $table->head = array("<b>$symbolstr</b>", "<b>$namestr</b>", "<b>$descriptionstr</b>", "<b>$resultstr</b>", "<b>$commandstr</b>");
        $table->align = array('center', 'left', 'left', 'left', 'left');
        $table->size = array('5%', '15%', '30%', '30%', '15%');
        $table->width = '80%';
        
        foreach($categories as $category){
            $commands = "<a href=\"{$CFG->wwwroot}/mod/magtest/view.php?id={$cm->id}&amp;what=editcategory&amp;catid={$category->id}\"><img src=\"{$CFG->pixpath}/t/edit.gif\"</a>";
            $commands .= " <a href=\"{$CFG->wwwroot}/mod/magtest/view.php?id={$cm->id}&amp;what=deletecategory&amp;catid={$category->id}\"><img src=\"{$CFG->pixpath}/t/delete.gif\"</a>";
            if ($category->sortorder > 1) {
                $commands .= "&nbsp;<a href=\"{$CFG->wwwroot}/mod/magtest/view.php?id={$cm->id}&amp;view=categories&amp;what=raisecategory&amp;catid={$category->id}\"><img src=\"{$CFG->pixpath}/t/up.gif\"></a>";
            } else {
                $commands .= "&nbsp;<img src=\"{$CFG->wwwroot}/mod/magtest/pix/up_shadow.gif\">";
            }
            if ($category->sortorder < count($categories)) {
                $commands .= "&nbsp;<a href=\"{$CFG->wwwroot}/mod/magtest/view.php?id={$cm->id}&amp;view=categories&amp;what=lowercategory&amp;catid={$category->id}\"><img src=\"{$CFG->pixpath}/t/down.gif\"></a>";
            } else {
                $commands .= "&nbsp;<img src=\"{$CFG->wwwroot}/mod/magtest/pix/down_shadow.gif\">";
            }
            $symbolurl = magtest_get_symbols_baseurl($magtest).$category->symbol;
            $symbolimage = "<img src=\"{$symbolurl}\" />";
            $table->data[] = array($symbolimage, format_string($category->name), format_string(format_text($category->description, $category->format)), format_string(format_text($category->result, $category->format)), $commands);
        }        
        print_table($table);
    } else {
        print_string('nocategories', 'magtest');
    }
    
    print_box_end();
    
    $options['id'] = $cm->id;
    $options['what'] = 'addcategories';
    $options['catnum'] = 1;
    print_single_button($CFG->wwwroot.'/mod/magtest/view.php', $options, get_string('addone', 'magtest'));
    $options['catnum'] = 3;
    print_single_button($CFG->wwwroot.'/mod/magtest/view.php', $options, get_string('addthree', 'magtest'));
    echo "</center>";

?>